%{
extern int yylex();
int yyerror(char *s) {printf("Error: %s\n", s); return(0);}
%}

%token tk_function
%token tk_variable
%token tk_real
%left '+' '-' '*' '/'

%%
input:   expr; 

expr:    tk_variable      {    Node noeud($1.name,-1,-1,syntax_tree.size());
                               $$.number=syntax_tree.size();
                               syntax_tree.push_back(noeud);
                          }
        |tk_real          {
                               Node noeud($1.name,-1,-1,syntax_tree.size());
                               $$.number=syntax_tree.size();
                               syntax_tree.push_back(noeud);
                          }
        |expr '+' expr    {    Node noeud(QString("+"),$1.number,$3.number,syntax_tree.size());
					 $$.number=syntax_tree.size();
                               syntax_tree.push_back(noeud);
                               }
        |expr '-' expr    {    Node noeud(QString("-"),$1.number,$3.number,syntax_tree.size());
					 $$.number=syntax_tree.size();
                               syntax_tree.push_back(noeud);
                          }
        |expr '*' expr    {    Node noeud(QString("*"),$1.number,$3.number,syntax_tree.size());
                               $$.number=syntax_tree.size();
                               syntax_tree.push_back(noeud);
                          }
        |expr '/' expr    {    Node noeud(QString("/"),$1.number,$3.number,syntax_tree.size());
                               $$.number=syntax_tree.size();
                               syntax_tree.push_back(noeud);
                          }
        |tk_function '(' expr ')'
			       {     Node noeud($1.name,$3.number,-1,syntax_tree.size());
                               $$.number=syntax_tree.size();
                               syntax_tree.push_back(noeud);
                         }
        |'(' expr ')'
;

%%
